<template>
  <div class="kit table simple">
    <div class="line sorting">
      <AppSelect
        v-model="sortValue"
        :options="sortOptions"
        track-by="name"
        label="name"
        placeholder="Сортировать по"
        class="no-checkbox"/>
    </div>
    <div class="line head table">
      <div class="unit part">
        <div class="part-photo"/>
        <div class="part-number">
          <button
            class="table-button-sorting"
            :class="sortClasses.name"
            @click="orderChange('name')">
            <span>Производитель и&nbsp;номер</span>
            <img
              svg-inline
              src="~/assets/svg/redesign/sorting-none.svg">
            <img
              svg-inline
              src="~/assets/svg/redesign/sorting.svg">
          </button>
        </div>
        <div class="part-name">Название</div>
      </div>
      <div class="unit applicability">Применяемость</div>
      <div class="unit price">Стоимость</div>
      <div class="unit offer">
        <button
          class="table-button-sorting"
          :class="sortClasses.count"
          @click="orderChange('count')">
          <span>Предложения продавцов</span>
          <img
            svg-inline
            src="~/assets/svg/redesign/sorting-none.svg">
          <img
            svg-inline
            src="~/assets/svg/redesign/sorting.svg">
        </button>
      </div>
    </div>

    <div
      class="line body table"
      v-for="item in list"
      :key="item.id">
      <div class="unit part">
        <div class="part-photo">
          <a
            v-if="images(item, ref.imageSizes.SMALL, 0)"
            href="#"
            @click.prevent="sliderAction(item)">
            <img
              :src="images(item, ref.imageSizes.SMALL, 0)"
              :alt="`${item.manufacturer.brand}, ${item.vendorCode}. ${item.name}`">
          </a>
          <img
            v-else
            src="~assets/images/no-photo.svg"
            alt="Нет фото">
        </div>
        <div class="part-number">
          <flink
            :href="href4Item(item)"
            class="link">
            {{ item.manufacturer.brand }}, {{ item.vendorCode }}
          </flink>
        </div>
        <div class="part-name">
          {{ item.name }}
        </div>
        <div class="part-desc">
          <div class="part-number">
            <flink
              :href="href4Item(item)"
              class="kit aqualink">
              <strong>{{ item.manufacturer.brand }}, {{ item.vendorCode }}</strong>
            </flink>
          </div>
          <div class="part-name">
            {{ item.name }}
          </div>
        </div>
      </div>
      <div class="unit applicability">
        <div class="value">
          <span>{{ getApplicabilityItems(item.applicability) }}</span>
          <span v-show="!item.applicability.length">&ndash;</span>
        </div>
        <button
          v-show="item.applicability.length"
          @click="showApplicability(item)"
          type="button"
          class="btn-more">
          <span>см.все</span>
        </button>
      </div>
      <div class="unit price">
        <div class="value">
          <template v-if="item.minPrice !== item.maxPrice">
            <span>{{ item.minPrice | spacifyNumber }}</span>
            &nbsp;-&nbsp;
            <span>{{ item.maxPrice | spacifyNumber }}&nbsp;руб.</span>
          </template>
          <template v-else>
            <span>{{ item.minPrice | spacifyNumber }}&nbsp;руб.</span>
          </template>
        </div>
      </div>
      <div class="unit offer _flex-center">
        <flink
          :href="href4Item(item)"
          class="button">
          {{ item.total | spacifyNumber }} {{ item.total | transChoose(['предложение', 'предложения', 'предложений']) }}
        </flink>
        <span
          v-if="item.hasCounterparts"
          class="substitutes"> Есть заменители </span>
      </div>
    </div>

    <no-ssr>
      <vue-easy-lightbox
        v-dom-move
        :visible="sliderModal.visible"
        :imgs="sliderModal.images"
        :index="0"
        @hide="sliderModal.visible = false"
      />
    </no-ssr>
  </div>
</template>

<script>
import { has, get } from 'lodash-es';
import AppSelect from '~/components/redesign/app-select/app-select';

import mapFilters from '~/assets/js/helpers/map-filters';
import imageSizes from '~/assets/js/enums/image-sizes';

export default {
  name: 'ResultTable',
  components: {
    AppSelect,
  },
  props: {
    list: {
      type: Array,
      required: true,
    },
    value: {
      type: Object,
      default() { return { field: null, direction: null }; },
    },
  },
  data() {
    return {
      sortOptions: [
        {
          field: 'name',
          direction: 'asc',
          name: 'по производителю ↑',
        },
        {
          field: 'name',
          direction: 'desc',
          name: 'по производителю ↓',
        },
        {
          field: 'count',
          direction: 'asc',
          name: 'по кол-ву предложений ↑',
        },
        {
          field: 'count',
          direction: 'desc',
          name: 'по кол-ву предложений ↓',
        },
      ],
      sliderModalImages: [],
      sliderModal: {
        images: [],
        visible: false,
      },
      ref: {
        imageSizes,
      },
    };
  },
  computed: {
    sortValue: {
      get() {
        return this.sortOptions.find(
          option => option.field === this.value.field && option.direction === this.value.direction,
        ) || null;
      },
      set(newValue) {
        this.$emit('input', {
          field: newValue.field,
          direction: newValue.direction,
        });
      },
    },
    sortClasses() {
      const direction = {
        count: 'none',
        name: 'none',
      };
      if (has(direction, this.value.field)) {
        direction[this.value.field] = (this.value.direction === 'asc' ? '-sorting-up' : '-sorting-down');
      }
      return direction;
    },
  },
  methods: {
    ...mapFilters(['brandSlug', 'vendorCodeSlug']),
    href4Item(item) {
      const url = ['/poisk-po-nomeru'];
      url.push(this.brandSlug(get(item, 'manufacturer.brand', '')));
      url.push(this.vendorCodeSlug(item.vendorCode));
      return url.join('/');
    },
    orderChange(field) {
      const emitting = { field, direction: 'asc' };
      if (field === this.value.field) {
        emitting.direction = this.value.direction === 'asc' ? 'desc' : 'asc';
      }
      this.$emit('input', emitting);
    },
    async showApplicability(item) {
      try {
        const { data: applicabilityData } = await this.$axios.$get('/_main/partInfo/getApplicability', {
          params: { id: item.id },
        });
        this.$emit('show-applicability', applicabilityData);
      } catch (e) {
        console.error(e);
      }
    },
    getApplicabilityItems(items) {
      return items.slice(0, 5).join(', ');
    },
    images(item, size = imageSizes.SMALL, index = null) {
      let images = [];

      if (item.imagesList && item.imagesList.length) {
        images = item.imagesList
          .map(image => image[`${size}Path`])
          .filter(image => Boolean(image));
      }

      if (index !== null) {
        if (images[index]) {
          return images[index];
        }
        return false;
      }
      return images;
    },
    sliderAction(item) {
      this.sliderModal.images = this.images(item, imageSizes.EXTRA);
      this.sliderModal.visible = true;
    },
  },
};
</script>

<style lang="postcss">
  .kit.table.simple {
    display: flex;
    flex-flow: column wrap;
    justify-content: flex-start;
    align-items: center;
    padding: 0;
    width: 100%;
    margin: 0;
    border-bottom: 0;
    @media screen and (min-width: 981px) {
      border-top: 1px solid #c5d1d9;
      border-left: 1px solid #c5d1d9;
      border-right: 1px solid #c5d1d9;
    }

    .line.sorting {
      @media screen and (max-width: 980px) {
        display: flex;
        flex-direction: row;
        flex-wrap: wrap;
        justify-content: flex-start;
        align-items: center;
        width: 100%;
        padding: 0.5rem 1rem 1.5rem 1rem;
        font-size: 0.875rem;
        font-weight: 500;
        > .label {
          padding-right: 1rem;
        }
      }
    }

    .line.table {
      display: flex;
      flex-flow: row nowrap;
      align-items: stretch;
      justify-content: space-between;
      height: auto;
      width: 100%;
      padding: 0;
      font-size: 0.8125rem;
      font-weight: 400;
      line-height: 1.3;
      @media screen and (min-width: 981px) {
        border-bottom: 1px solid #c5d1d9;
        &.body:hover {
          box-shadow: 0 4px 8px 0 rgba(96, 126, 146, 0.15);
        }
      }
      @media screen and (max-width: 980px) {
        border: 1px solid #c5d1d9;
        box-shadow: 0 4px 4px rgba(0, 0, 0, .1);
        margin-bottom: 1rem;
      }
      .unit {
        display: inline-flex;
        justify-content: flex-start;
        align-items: flex-start;
        overflow: hidden;
        @media screen and (max-width: 980px) {
          padding-left: 0.75rem;
          padding-right: 0.75rem;

          &.part {
            order: 1
          }
          &.offer {
            order: 4;
          }
          &.price {
            order: 2;
          }
          &.applicability {
            order: 3;
          }
        }
        @media (min-width: 981px) and (max-width: 1200px) {
          padding: 0.625rem 0.5rem;
          font-size: 0.75rem;
          &:first-of-type {
            padding-left: 1rem !important;
          }
          &:last-of-type {
            padding-right: 1rem !important;
          }

          &.part {
            flex-direction: column;
            justify-content: flex-start;
            width: calc(100% / 2 - 14%);
            padding: 1rem 0.5rem;
            .part-photo {
              width: 3rem;
              height: 3rem;
              // border: 1px solid #9badb9;

              img {
                display: block;
                width: inherit;
                height: inherit;
                max-width: 3rem;
                max-height: 3rem;
                object-fit: contain;
              }
            }
            .part-number {
              width: 100%;
              padding-top: 8px;
            }
            .part-name {
              width: 100%;
            }
          }
          &.applicability {
            width: calc((100% - 13rem) / 4 + 6%);
          }
          &.offer {
            justify-content: center;
            width: 13rem;
          }
          &.price {
            width: calc(100% / 3);
            padding-left: 1rem;
            justify-content: flex-end;
          }
        }
        @media screen and (min-width: 1201px) {
          padding: 0.5rem;
          font-size: 0.75rem;
          &:first-of-type {
            padding-left: 1rem !important;
          }
          &:last-of-type {
            padding-right: 1rem !important;
          }

          &.part {
            width: calc(100% / 2 - 2%);

            .part-photo {
              display: flex;
              justify-content: center;
              align-items: center;
              margin-right: 0.5rem;
              width: 5rem;
              overflow: hidden;
              background-color: transparent;

              img {
                display: block;
                width: inherit;
                height: inherit;
                max-width: 5rem;
                max-height: 3.75rem;
                object-fit: contain;
              }
            }
            .part-number {
              width: 10rem;
              padding-right: 1rem;
            }
            .part-name {
              width: calc(100% - 16rem);
            }
          }
          &.applicability {
            width: calc((100% - 15rem) / 4 + 4%);
            max-width: 350px;
            overflow: hidden;

            & > .value {
              width: 100%;
              text-overflow: ellipsis;
              overflow: hidden;
              white-space: nowrap;
            }
          }
          &.price {
            width: calc(100% / 5 + 1%);
            padding: 0.5rem 1rem 0.5rem 0.5rem;
            justify-content: flex-end;
          }
          &.offer {
            justify-content: center;
            width: 15rem;
            padding: 0.5rem 0.5rem;
          }
        }

      }
    }

    .line.head.table {
      width: 100%;
      min-height: 3rem;
      text-align: left;
      font-size: 0.8125rem;
      font-weight: 700;
      padding: 0;
      color: #272727;
      .unit {
        padding-top: 0.5rem;
        padding-bottom: 0.5rem;
        align-items: center;
        .kit.sorting .label {
          display: block;
          width: auto;
          white-space: normal;
        }

        @media (min-width: 981px) and (max-width: 1200px) {
          &.part {
            .part-photo {
              display: none;
            }
          }
        }
      }
      @media screen and (max-width: 980px) {
        display: none;
        font-size: 0.75rem;
      }
    }

    .line.body.table {
      .unit {
        flex-flow: row wrap;
        color: #141414;
        &.applicability {
          display: block;
          .value {
            display: block;
          }
          .btn-more {
            display: inline-block;
            background-color: #ffffff;
            outline: none;
            color: #558fcc;
            font-size: inherit;
            padding: 0;
            margin-left: 0;
            cursor: pointer;
            border: none;
            border-bottom: 1px solid transparent;
            &:hover span {
              text-decoration: underline;
            }
            /*&:before {*/
            /*  content: '...';*/
            /*  color: #141414;*/
            /*  padding: 0 0.375rem 0 0;*/
            /*  text-decoration: none !important;*/
            /*}*/

            &.-notTrim {
              margin-left: 0;

              /*&::before {*/
              /*  content: none;*/
              /*}*/
            }
          }
        }
        &.price {
          span {
            display: inline-block;
            white-space: nowrap;
          }
        }
        &.offer {
          .analog {
            display: block;
            width: 100%;
            text-align: center;
            color: #9BADB9;
            margin: 0.5rem auto auto;
          }
        }
      }
      @media screen and (max-width: 980px) {
        position: relative;
        flex-direction: column;
        flex-wrap: wrap;
        padding: 1rem 0;

        .unit {
          &.part {
            justify-content: flex-start;
            align-items: flex-start;

            flex-wrap: nowrap;
            font-size: 1.25rem;
            line-height: 1.2;
            font-weight: 400;
            .kit.aqualink {
              font-weight: 700;
              color: inherit;
              pointer-events: none;
            }
            .part-photo {
              margin-right: 8px;
              width: 5rem;
              height: 5rem;

              img {
                display: block;
                width: inherit;
                height: inherit;
                max-width: 5rem;
                max-height: 5rem;
                object-fit: contain;
              }
            }

            & > .part-name,
            & > .part-number {
              display: none;
            }
          }
          &.applicability {
            font-size: 1rem;
            padding-bottom: 1.5rem;
            color: #9BADB9;
            .value .btn-more {
              margin-left: -1.75rem;
              span {
                text-decoration: underline;
              }
              &:before {
                color: #9BADB9;
                padding-right: 0.75rem;
                padding-left: 0.25rem;
              }
            }
          }
          &.offer {
            .button {
              width: 100%;
            }
            .analog {
              font-size: 1rem;
            }
          }
          &.price {
            padding-top: 1rem;
            padding-bottom: 1rem;
            font-size: 1.25rem;
            font-weight: 700;
          }
        }
      }
      @media screen and (min-width: 981px) {
        .unit {
          flex-flow: row wrap;
          color: #4a4a4a;

          &.manufacturer {
            font-weight: 500;
          }
          &.offer {
            align-items: flex-start;
            .ui.button {
              width: 100%;
              margin: 0;
            }
          }
          &.price {
            .value {
              text-align: right;
            }
            align-items: flex-start;
            font-size: 0.75rem;
            line-height: 1.3;
            font-weight: 700;
          }
        }
      }
    }
  }

  .part-desc {
    display: none;
  }

  .substitutes {
    align-self: flex-start;
    height: calc(100% - 32px);
    margin-top: 10px;
    font-size: 0.6875rem;
  }

  ._flex-center {
    justify-content: center!important;
  }

  .line.sorting {
    display: none;
  }

  @media screen and (max-width: 980px) {
    .part-desc {
      display: flex;
      flex-direction: column;

      & > .part-number {
        padding-bottom: 8px;
      }
    }

    .substitutes {
      margin-top: 20px;
    }
  }

  .line.head.table {
    /*TODO: Нужен отдельный компонент для таких кнопок */
    & .table-button-sorting {
      display: flex;
      align-items: flex-start;
      width: auto;
      padding: 0;
      margin: 0;
      font: inherit;
      color: inherit;
      white-space: nowrap;
      text-align: inherit;
      border: none;
      box-shadow: none;
      background: none;
      cursor: pointer;

      > span {
        display: block;
        width: max-content;
      }

      .svg {
        display: block;
        flex-shrink: 0;
        margin-left: 0.25rem;
        margin-top: 0.25rem;
      }

      .svg-sorting {
        display: none;
      }

      &.-sorting-up {
        .svg-sorting {
          display: block;
          transform: rotate(180deg);
        }
        .svg-no-sorting {
          display: none;
        }
      }

      &.-sorting-down {
        .svg-sorting {
          display: block;
        }
        .svg-no-sorting {
          display: none;
        }
      }
    }
  }

</style>
